;|
Dominique VAQUAND
25.02.2022
www.dovaq.fr
=================================================
 Vrification pente et angle d'un tuyau Plant 3D 
=================================================
|;

(defun c:AP3D_VerifPenteTuyau ( / ObjSelection pt1 pt2 Pt1_XY pt2_XY Long_Tuyau Long_Tuyau_XY Delta_Z Pente_Tuyau Angle_Tuyau)

  (setvar "cmdecho" 0)

  (defun *error* (s)
    (command-s "_ucs" "_p")
    (setq *error* nil)
    )

  (setq ObjSelection T)

  (while ObjSelection

  (princ "\nSlectionnez un tuyau: ")
  (setq ObjSelection (entget (car (entsel))))

;; Vrification que l'objet slectionn est bien un tuyau
  (if (= (cdr (assoc 0 ObjSelection)) "ACPPPIPE")
    (progn

  	(command "_ucs" "")

;; Rcupre les coordonnes du point dbut et fin du tuyau
    	(setq Pt1 (cdr (assoc 10 (reverse ObjSelection))))
    	(setq Pt2 (cdr (assoc 11 (reverse ObjSelection))))

;; Calcul longueur du tuyau
      (setq Long_Tuyau (distance Pt1 Pt2))

;;;  	(setq distance_X (abs (- (car pt1) (car pt2)))
;;;	      distance_Y (abs (- (cadr pt1) (cadr pt2)))
;;;	      )
;;;        (setq Distance_XY (sqrt (+ (expt distance_x 2) (expt distance_y 2))))

;; Projection en XY des points PT1 et PT2      
     	(setq Pt1_XY (list (car pt1) (cadr pt1) 0))
      	(setq pt2_XY (list (car pt2) (cadr pt2) 0))
  	(setq Long_Tuyau_XY (distance Pt1_xy Pt2_xy))

;; Calcul distance en Z
      	(setq Delta_Z (abs (float (- (caddr pt1) (caddr pt2)))))

         (if (equal Pt1_XY pt2_XY)
	   (alert "Tuyau vertical")
	  (progn

;; Calcul pente du tuyau
      (setq Pente_Tuyau 	

      (strcat "Pente = " (rtos (abs (* 100.0 (/ Delta_Z Long_Tuyau_xy))) 2 1) "%")
	    )

;; Calcul angle du tuyau
     (setq Angle_Tuyau (strcat "Angle = " (rtos (abs (* (atan (/ Delta_Z Long_Tuyau_xy)) (/ 180 pi))) 2 1) ""))

 ;; Affichage sur ligne de commande
      (princ (strcat "Vrification Pente : " Pente_Tuyau "  " Angle_tuyau))

 ;; Affichage des informations Pente et Angle 						   
      (alert (strcat "Vrification Pente\n\n" Pente_Tuyau "\n" Angle_tuyau))

      )
	   )

  (command-s "_ucs" "_p")

      ); fin condition vrai

    (alert "Cet objet n'est pas un tuyau")
    ); Fin de la condition

    ); fin du while

  (princ)
  
  ); fin du programme

 